SkillsPlusFuLt = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0",
                                              "AceConsole-2.0",
                                              "AceDB-2.0",
                                              "AceEvent-2.0"
                                              )
-- variables
local L       = AceLibrary("AceLocale-2.2"):new("SkillsPlusFuLt")
local crayon  = AceLibrary("Crayon-2.0")
local tablet  = AceLibrary("Tablet-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")

local chosenProfession = L["FUBAR_LABEL"]
local chosenProfessionIcon = select(3, GetSpellInfo(4036)) -- engineering
local toonSaveKey = ''
                     
-- set properties                                             
SkillsPlusFuLt.clickableTooltip = true
SkillsPlusFuLt.canHideText      = true
SkillsPlusFuLt.defaultPosition  = "RIGHT"
SkillsPlusFuLt.hasIcon          = chosenProfessionIcon
SkillsPlusFuLt.hasNoColor       = true

-- register stuff
SkillsPlusFuLt:RegisterDB("SkillsPlusFuLtDB")
SkillsPlusFuLt:RegisterDefaults("char", {
                                lastUsed = '',          -- last used skill
                                lastUsedIcon = select(3, GetSpellInfo(4036)), -- engineering
                                -- flags
                                showBooleanSkills = false,
                                -- lists
                                hidden = {},} )
SkillsPlusFuLt:RegisterDefaults("account", {
                                -- lists
                                toonSave = {},} 
                             )
SkillsPlusFuLt:RegisterChatCommand(L["CMD_OPTIONS"])

-- methods
function SkillsPlusFuLt:OnInitialize()
    self.labelName = L["FUBAR_LABEL"]
	self.skillList = {}
end

function SkillsPlusFuLt:OnEnable()
    -- skills management
	self:RegisterEvent("SKILL_LINES_CHANGED","Update")
	self:RegisterEvent("PLAYER_LEVEL_UP","Update") 
    -- variables
    toonSaveKey = GetCVar('realmName')..'|'..UnitName('player')
   
    self:UpdateToonInfo()
    self:Update()
end

-- toon management
function SkillsPlusFuLt:UpdateToonInfo()
    if (self.db.account.toonSave[toonSaveKey] == nil) then
        self.db.account.toonSave[toonSaveKey] = {}
    end
    
    if (chosenProfession == L["FUBAR_LABEL"]) and
       (self.db.char.lastUsed ~= '') then
        chosenProfession = self.db.char.lastUsed
        chosenProfessionIcon = self.db.char.lastUsedIcon
    else
        self.db.char.lastUsed = chosenProfession
        self.db.char.lastUsedIcon = chosenProfessionIcon
    end
end

dewdropPurgeFunction = function(self,toonKey) self:PurgeCharacterData(toonKey) end

function SkillsPlusFuLt:PurgeCharacterData(toonKey)
    self.db.account.toonSave[toonKey] = nil
    self:Update()
end

-- skills management

function SkillsPlusFuLt:ToggleCategory(id, button)
	if self.db.char.hidden[id] then
		self.db.char.hidden[id] = false
	else
		self.db.char.hidden[id] = true
	end
	-- Refresh in place
	self:UpdateTooltip()
end


-- skills management

function SkillsPlusFuLt:AddProfessionLine(skillName)
        -- Alchemy
		if (skillName == GetSpellInfo(2259)) then
			local spellname,_,tmpicon = GetSpellInfo(2259)
       		dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
	-- Archaeology
	if (skillName == GetSpellInfo(78670)) then
		local spellname,_,tmpicon = GetSpellInfo(78670)
		dewdrop:AddLine(
			'text', spellname,
			'func', function() CastSpellByName(spellname)
							   self:UpdateText(spellname,tmpicon)
					end,
			'closeWhenClicked', true,                
			'arg1', self
			)
	end	
	-- Blacksmithing
        if (skillName == GetSpellInfo(2018)) then
			local spellname,_,tmpicon = GetSpellInfo(2018)
       		dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                         end,
                'closeWhenClicked', true,                
      			'arg1', self
                )
        end
		-- Cooking
        if (skillName == GetSpellInfo(2550)) then
			local spellname,_,tmpicon = GetSpellInfo(2550)
       		dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
		-- Enchanting
        if (skillName == GetSpellInfo(7411)) then
       		local spellname,_,tmpicon = GetSpellInfo(7411)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
		-- Engineering
        if (skillName == GetSpellInfo(4036)) then
			local spellname,_,tmpicon = GetSpellInfo(4036)
       		dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
		-- First Aid
        if (skillName == GetSpellInfo(3273)) then
			local spellname,_,tmpicon = GetSpellInfo(3273)
       		dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
        -- Inscription 
        if (skillName == GetSpellInfo(45357)) then
       		local spellname,_,tmpicon = GetSpellInfo(45357)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                         end,
                'closeWhenClicked', true,                
      			'arg1', self
                )
        end
		-- Jewelcrafting
        if (skillName == GetSpellInfo(25229)) then
       		local spellname,_,tmpicon = GetSpellInfo(25229)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                         end,
                'closeWhenClicked', true,                
      			'arg1', self
                )
        end
		-- Leatherworking
        if (skillName == GetSpellInfo(2108)) then
       		local spellname,_,tmpicon = GetSpellInfo(2108)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                         end,
                'closeWhenClicked', true,                
      			'arg1', self
                )
        end
		-- Mining
        if (skillName == GetSpellInfo(2575)) then
       		local spellname,_,tmpicon = GetSpellInfo(2656)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
		-- Poisons
        if (skillName == GetSpellInfo(2842)) then
       		local spellname,_,tmpicon = GetSpellInfo(2842)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
		-- Tailoring
        if (skillName == GetSpellInfo(3908)) then
       		local spellname,_,tmpicon = GetSpellInfo(3908)
			dewdrop:AddLine(
        		'text', spellname,
	        	'func', function() CastSpellByName(spellname)
                                   self:UpdateText(spellname,tmpicon)
                        end,
                'closeWhenClicked', true,                
       			'arg1', self
                )
        end
end

function SkillsPlusFuLt:OnMenuRequest(level, value)
	if level == 1 then
        	for _,category in pairs(self.skillList) do
			for _,skill in pairs(category.skills) do              
				self:AddProfessionLine(skill.name)
			end
                end
		
       		dewdrop:AddLine()				-- spacer
		
		dewdrop:AddLine(
			'text', L["MENU_PURGE_CHARACTER"],      -- stub for popup
			'arg1', self,
			'hasArrow', true,
			'value', "PURGE"
		)              
	elseif level == 2 then
		if value == "PURGE" then
            for k, v in pairs(self.db.account.toonSave) do
                local toonName = string.sub(k,string.find(k,'|')+1)
                local realmName = string.sub(k,1,string.find(k,'|')-1)
                if (toonName ~= UnitName('player')) and
                   (realmName == GetCVar('realmName')) then
                    local toonKey = realmName..'|'..toonName            
    				dewdrop:AddLine(
	    				'text', toonName,
                        'arg1', self, 'arg2', toonKey,
                        'func', dewdropPurgeFunction,
                        'closeWhenClicked', true
				    )
                end
			end
		end    
	end
end

function SkillsPlusFuLt:OnDataUpdate()
	local skillIndex = 0
	local skillList = {}
	local headerIndex = 1
	
	-- alternative found on wowpedia.org
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()
	table.insert(skillList, {category=L["FUBAR_LABEL"], skills={}})
	
	if prof1 ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, skillModifier = GetProfessionInfo(prof1)
                table.insert(skillList[headerIndex].skills, {name = name,  rank = skillLevel,
                             maxrank = maxSkillLevel})
	end
	if prof2 ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, skillModifier = GetProfessionInfo(prof2)
                table.insert(skillList[headerIndex].skills, {name = name,  rank = skillLevel,
                             maxrank = maxSkillLevel})
	end
	if archaeology ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, skillModifier = GetProfessionInfo(archaeology)
                table.insert(skillList[headerIndex].skills, {name = name,  rank = skillLevel,
                             maxrank = maxSkillLevel}) 
	end
	if fishing ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, skillModifier = GetProfessionInfo(fishing)
                table.insert(skillList[headerIndex].skills, {name = name,  rank = skillLevel,
                             maxrank = maxSkillLevel}) 
	end
	if cooking ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, skillModifier = GetProfessionInfo(cooking)
                table.insert(skillList[headerIndex].skills, {name = name,  rank = skillLevel,
                             maxrank = maxSkillLevel}) 
	end
	if firstAid ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, skillModifier = GetProfessionInfo(firstAid)
                table.insert(skillList[headerIndex].skills, {name = name,  rank = skillLevel,
                             maxrank = maxSkillLevel}) 
	end
	
	self.skillList = skillList
end

function SkillsPlusFuLt:UpdateText(newProfession,newIcon)
    if newIcon ~= nil then 
        chosenProfessionIcon = newIcon
    end   
    if newProfession ~= nil then 
        chosenProfession = newProfession 
        self:UpdateToonInfo()  -- set lastUsed variable
    end
    
    self:SetText(chosenProfession)
    self:SetIcon(chosenProfessionIcon) 
end

function SkillsPlusFuLt:OnTooltipUpdate()
	tablet:SetHint(L["TOOLTIP_HINT"])
	
	for _,category in pairs(self.skillList) do
		local cat = tablet:AddCategory(
			'id', category.category, 'columns', 2,
			'text', category.category,
			'func', 'ToggleCategory', 'arg1', self, 'arg2', category.category,
			'child_textR', 1, 'child_textG', 1, 'child_textB', 0,
			'showWithoutChildren', true,
			'checked', true, 'hasCheck', true, 'checkIcon', self.db.char.hidden[category.category] and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up"
		)
		if not self.db.char.hidden[category.category] then
			for _,skill in pairs(category.skills) do
				if skill.maxrank > 1 then
					local rank = skill.rank
					rank = rank.."/"..skill.maxrank
					local r,g,b = crayon:GetThresholdColor(skill.rank / skill.maxrank)
					cat:AddLine(
						'text', skill.name, 'text2', rank, 
						'text2R', r, 'text2G', g, 'text2B', b)
				elseif self:IsShowingBooleanSkills() then
					cat:AddLine('text', skill.name)
				end
			end
		end
	end
end

function SkillsPlusFuLt:OnClick()
    if self.chosenProfession == L["FUBAR_LABEL"] then
        ToggleCharacter("SkillFrame")
    else
        CastSpellByName(chosenProfession)
    end
end